#!/usr/bin/perl -w

use PerlLib::SwissArmyKnife;

use Net::IMAP::Client;

my $imap = Net::IMAP::Client->new
  (

   server => QueryUser("Hostname"),
   user   => QueryUser("Username"),
   pass   => QueryUser("Password"),
   ssl    => 1,			# (use SSL? default no)
   # port   => 993		# (but defaults are sane)

  ) or die "Could not connect to IMAP server";

# everything's useless if you can't login
$imap->login or
  die('Login failed: ' . $imap->last_error);


# let's see what this server knows (result cached on first call)
my $capab = $imap->capability;
# or
my $knows_sort = $imap->capability( qr/^sort/i );

# get list of folders
my @folders = $imap->folders;

# print Dumper(\@folders);

# get total # of messages, # of unseen messages etc. (fast!)
# my $status = $imap->status(@folders); # hash ref!

# select folder
$imap->select('INBOX');

# get folder hierarchy separator (cached at first call)
my $sep = $imap->separator;

# fetch all message ids
my @messages = $imap->search('ALL');

# # fetch all ID-s sorted by subject
# my $messages = $imap->search('ALL', 'SUBJECT');
# # or
# my @messages = $imap->search('ALL', [ 'SUBJECT' ]);

# fetch ID-s that match criteria, sorted by subject and reverse date
# my $messages = $imap->search({
# 			      FROM    => 'foo',
# 			      SUBJECT => 'bar',
# 			     }, [ 'SUBJECT', '^DATE' ]);

# fetch message summaries (actually, a lot more)
my $summaries = $imap->get_summaries($messages[0]);
foreach (@$summaries) {
  print join(', ', $_->uid, $_->subject, $_->date, $_->rfc822_size, @{$_->from})."\n";
  my $data = $imap->get_rfc822_body($_->uid);
  print $$data;
}
die('Success');
