#!/usr/bin/perl -w

use Capability::NER;
use PerlLib::MySQL;
use PerlLib::SwissArmyKnife;
use PerlLib::ToText;

my $mysql = PerlLib::MySQL->new
  (DBName => "js_rapid_response_test");
my $totext = PerlLib::ToText->new
  ();
my $ner = Capability::NER->new;

my $res = $mysql->Do(Statement => "select ID, description from entries;");
foreach my $key (keys %$res) {
  my $res2 = $totext->ToText
    (
     String => $res->{$key}->{description},
    );
  my @ner;
  # print Dumper($res2);
  # now process with named entity extraction
  if ($res2->{Success}) {
    my $res3 = $ner->NERExtract
      (
       Text => $res2->{Text},
      );
    # print Dumper($res3);
    foreach my $entry (@$res3) {
      if ($entry->[1] eq "ORGANIZATION") {
	push @ner, join(" ",@{$entry->[0]});
      }
    }
  }
  print Dumper(\@ner);
}
