#!/usr/bin/perl -w

use PerlLib::SwissArmyKnife;

use Tk;
use Manager::Dialog qw(Approve);

my $mw = MainWindow->new;

$UNIVERSAL::managerdialogtkwindow = $mw;

my $item;
my $text = $mw->Text
  (
   -width => 80,
   -height => 30,
  )->pack();

$text->Contents
  ('                                 [env-banner]
                                   [env-sum]
                                    [blue3]

                   TO APPLY CALL 847-424-1639 ASK FOR CHRIS

                     Or call 896-2271

           Make $4,000-$6,000 this summer. Hourly wage: $9-$15/hr
(312) 684 7719

                               [apply-bar-round]
                [social-media-twitter] [social-media-facebook]
');

MarkupText();

MainLoop;


sub MarkupText {
  my %args = @_;
  # go ahead and find all phone numbers
  my $c = $text->Contents;
  my @phonenumbers = $c =~ /(((.(\d\d\d).|(\d\d\d)).)?(\d{3}).(\d{4}))/sg;
  print Dumper(\@phonenumbers);
  my $items = {};
  while (@phonenumbers) {
    my $number = shift @phonenumbers;
    shift @phonenumbers;
    shift @phonenumbers;
    my $areacode1 = shift @phonenumbers;
    my $areacode2 = shift @phonenumbers;
    my $localcode = shift @phonenumbers;
    my $lastcode = shift @phonenumbers;
    $items->{$number} = join("-",$areacode1 || $areacode2 || "630",$localcode,$lastcode);
  }

  # print Dumper($items);
  my $i = 0;
  foreach my $string (keys %$items) {
    # get the start and end location of this string
    my $res =
      GetLocation
      (
       String => $c,
       Substring => $string,
       Result => $items->{$string},
      );
    foreach my $entry (@$res) {
      print Dumper($entry);
      # $text->configure(-state => "disabled");
      $text->tagConfigure("phonenumber-$i", -background => "yellow");
      # $text->configure(-state => "disabled");
      my @args2 =
	(
	 "phonenumber-$i",
	 '<Button-1>',
	 sub {
	   my $pn = $entry->{PhoneNumber};
	   $pn =~ s/\D//g;
	   my $command = "twinkle --call 001$pn &";
	   if (Approve("Perform command: $command")) {
	     system "$command";
	   }
	 },
	);
      print Dumper(\@args2);
      $text->tagBind(@args2);
      $text->tagAdd("phonenumber-$i", $entry->{Start}, $entry->{End});
      print "<$i>\n";
      ++$i;
    }
  }

}

sub GetLocation {
  my %args = @_;
  my $string = $args{String};
  my $substrlen = length($args{Substring});
  my $i = 1;
  my @res;
  foreach my $line (split /\n/, $string) {
    my $linelen = length($line);
    foreach my $j (0..($linelen - $substrlen)) {
      my $substr = substr $line, $j, $substrlen;
      # print "<$substr>\n";
      if ($substr eq $args{Substring}) {
	push @res, {
		    String => $substr,
		    PhoneNumber => $args{Result},
		    Start => $i.".".$j,
		    End => $i.".".($j+$substrlen),
		   };
      }
    }
    ++$i;
  }
  return \@res;
}
