#!/usr/bin/perl -w

# remove previous column when doing update

# actually update the database

# do the functions as a result of the state transition requests

# remap everything to object oriented code

# actually calculate ethics and similarity scores

# add profiles for resumes

# # truncate similarity to appropriate length

# make certain fields immutable

# calculate IRT

# color code the posting date according to expired time

# have the threshold and search actually work

# have it actually send out letters

# have someone review the addresses

# have it store the intermediate materials more appropriately

# have the ability to show everything that we've applied for

# have the proper email addresses added

# have the imap client, autoanalyzer and gui working working





use BOSS::Config;
use Manager::Dialog qw(Approve ApproveCommands);
use PerlLib::MySQL;
use PerlLib::SwissArmyKnife;

use Tk;
use Tk::TableMatrix;
use WWW::Mechanize;
use XML::Simple;

$specification = q(
	-a		Use actual RSS feed, instead of cached
);

my $config =
  BOSS::Config->new
  (Spec => $specification);
my $conf = $config->CLIConfig;
# $UNIVERSAL::systemdir = "/var/lib/myfrdcsa/codebases/minor/js-rapid-response";

my $mech = WWW::Mechanize->new;
my $mysql = PerlLib::MySQL->new
  (
   DBName => "js_rapid_response",
  );

my $top1 = MainWindow->new
  (
   -title => "Job-Search Rapid Response Tool",
   -height => 600,
   -width => 800,
  );
$UNIVERSAL::managerdialogtkwindow = $top1;

$frame = $top1->Frame(-relief => 'flat');
$frame->pack(-side => 'top', -fill => 'both', -expand => 1, -anchor => 'center');

$menu = $top1->Frame(-relief => 'raised', -borderwidth => '1');
$menu->pack(-before => $frame, -side => 'top', -fill => 'x');

$menu_file = $menu->Menubutton
  (
   -text => 'File',
   -tearoff => 0,
   -underline => 0,
  );

$menu_file->command
  (
   -label => 'Load Profile',
   -command => sub { },
   -underline => 0,
  );

$menu_file->command
  (
   -label => 'Exit',
   -command => sub { },
   -underline => 0,
  );

$menu_file->pack
  (
   -side => 'left',
  );

# okay we will need the system, which

my $topframe = $top1->Frame();

$searchframe = $topframe->Frame();
my $searchtext = "";
$searchframe->Entry
  (
   -textvariable => \$searchtext,
  )->pack(-side => "left");

$searchframe->Button
  (
   -text => "Search Jobs",
   -command => sub {
     UpdateDisplay
       (
	Search => $searchtext,
       );
   },
  )->pack(-side => "right");
$searchframe->pack
  (
   -side => "left",
  );

my $thresholdframe = $topframe->Frame;
my $min = 0;
my $max = 100;
my $cutofflabel = $thresholdframe->Label
  (
   -text => "Threshold",
  )->pack(-side => "left");
my $cutoff = $thresholdframe->Scale
  (
   -orient => "horizontal",
   -from => $min,
   -to => $max,
  )->pack(-side => "right");
$cutoff->set(80);
$thresholdframe->pack
  (
   -side => "right",
  );

$topframe->pack(-side => "top");

$tableframe = $top1->Frame();
$tableframe->pack(-fill => "both", -expand => 1);

$buttonframe = $top1->Frame();
$buttonframe->Button
  (
   -text => "Update",
   -command => sub { 
     UpdateDatabaseFromRSSFeed();
   },
  )->pack(-side => "left");
$buttonframe->Button
  (
   -text => "Refresh",
   -command => sub { 
     UpdateDisplay();
   },
  )->pack(-side => "left");
$buttonframe->Button
  (
   -text => "Exit",
   -command => sub { 
     if (Approve("Exit Program?")) {
       exit(0);
     }
   },
  )->pack(-side => "right");
$buttonframe->pack(-side => "bottom");

# auto update every now and then

# have the ability to search entries based on different parameters

# when we click on it, it brings up window program, which allows us to
# send or quit.  the time, etc, everything, happens as it should.
# we'll integrate the other stuff later

UpdateDisplay();

MainLoop;

sub UpdateDatabaseFromRSSFeed {
  my %args = @_;
  # get it, try using with WWW::Mechanize;

  my $xml;
  if (exists $conf->{'-a'}) {
    $mech->get("http://chicago.craigslist.org/jjj/index.rss");
    my $content = $mech->content();
    $xml = XMLin($content);
  } else {
    my $rssfile = "/var/lib/myfrdcsa/codebases/minor/js-rapid-response/data/index.rss";
    my $c = read_file($rssfile);
    $xml = XMLin($c);
  }
  # load all of the entries into the DB if they haven't been seen before
  # update all the entries into the pane
  # add to the database

  # load the existing urls
  my $sources = {};
  my $res1 = $mysql->Do(Statement => "select ID,dc_source from entries;");
  foreach my $key (keys %$res1) {
    $sources->{$res1->{$key}->{dc_source}} = 1;
  }
  foreach my $item (reverse @{$xml->{item}}) {
    if (! exists $sources->{$item->{"dc:source"}}) {
      # can go ahead and add it
      my @values1 = (undef);
      foreach my $key
	(qw(title link description dc_date dc_language
	    dc_rights dc_source dc_title dc_type dcterms_issued)) {
	my $key2 = $key;
	$key2 =~ s/_/:/g;
	push @values1, $item->{$key2};
      }
      $mysql->Insert
	(
	 Table => "entries",
	 Values => \@values1,
	);
      my $id = $mysql->InsertID;
      # ID, Entry_Id, Status, IRT
      my @values2 = (undef,$id,"unread",undef);
      $mysql->Insert
	(
	 Table => "metadata",
	 Values => \@values2,
	);
    } else {
      # otherwise it already exists
      print "Already exists: ".$item->{"dc:source"}."\n";
    }
  }
}

sub UpdateDisplay {
  my %args = @_;
  # remove any preexisting tables
  $tableframe->children;
  
  # FIXME
  my @allkeys = qw(ID title link description dc_date dc_language dc_rights dc_source dc_title dc_type dcterms_issued);
  my @keys = ("ID", "title", "dc_date");
  my $propername =
    {
     ID => "ID",
     title => "Title",
     "dc_date" => "Posting Date",
    };
  # here are some additional flags
  # indicate unread visually
  my $statuses = {
		  "unread" => {
			       Color => "Red",
			      },
		  "seen" => {
			     Color => "Black",
			    },
		  "ignored" => {
				Color => "Black",
			       },
		  "applied for" => {
				    Color => "Black",
				   },
		  "heard back" => {
				   Color => "Black",
				  },
		  "their turn" => {
				   Color => "Black",
				  },
		  "my turn" => {
				Color => "Black",
			       },
		  "job acquired" => {
				     Color => "Black",
				    },
		  "job quit" => {
				 Color => "Black",
				},
		  "job finished" => {
				     Color => "Black",
				    },
		 };


  # my @additional = ("Status","IRT","History","Similarity","Apply");
  my @additional = ("Ethics","Similarity","Status","IRT");

  # basically do a search here

  my $res1 = $mysql->Do
    (
     Statement => "select * from entries;",
    );

  my $res2 = $mysql->Do
    (
     Statement => "select * from metadata;",
    );
  foreach my $key (keys %$res2) {
    $entryids->{$res2->{$key}->{Entry_ID}} = $key;
  }

  # where field like $args{Search};
  # do a spreadsheet view of all the relevant items
  my $numberofrows = scalar keys %$res1;

  # get the size
  my $table = $tableframe->Scrolled
    (
     "TableMatrix",
     # -resizeborders => 'none',
     -titlerows => 1,
     -rows => $numberofrows,
     -colstretchmode => 'all',
     -cols => ((scalar @keys) + (scalar @additional)),
     -cache => 1,
     -scrollbars => "osoe",
    );

  # add some other stuff for other fields as needed

  my $col2 = 0;
  foreach my $fieldname (@keys) {
    # $table->insertCols("$col2.0", 1);
    $table->set("0,$col2", $propername->{$fieldname});
    ++$col2;
  }
  foreach my $fieldname (@additional) {
    # $table->insertCols("$col2.0", 1);
    $table->set("0,$col2", $fieldname);
    ++$col2;
  }
  $table->colWidth(1, 60);
  $table->colWidth(2, 20);
  $table->colWidth(3, 5);

  my $row = 1;
  # sort by date first of all, not by number as if we use a limited format...  ID cannot be important

  foreach my $key (sort {$res1->{$b}->{dc_date} cmp $res1->{$a}->{dc_date}} keys %$res1) {
    my $col3 = 0;
    foreach my $fieldname (@keys) {
      $table->set("$row,$col3", $res1->{$key}->{$fieldname});
      ++$col3;
    }
    foreach my $fieldname (@additional) {
      my $id = $entryids->{$key};
      if ($fieldname eq "Status") {
	# set the color based on the status
	my $status = $res2->{$id}->{$fieldname};
	my $color = $statuses->{$status}->{Color};
	if ($status eq "unread") {
	  # set the color based on the status
	  my $button = $table->Button
	    (
	     -text => $status,
	     -background => $color,
	     -command => sub {
	       PerformStateTransition
		 (
		  Key => $key,
		  Status => $status,
		 );
	     },
	    );
	  $table->windowConfigure
	    (
	     "$row,$col3",
	     -window => $button,
	     -sticky => 'nsew',
	    );
	} else {
	  my $blank = $table->Label
	    (
	     -text => $status,
	     -background => $color,
	     -cursor => ['left_ptr'],
	    );
	  $table->windowConfigure
	    (
	     "$row,$col3",
	     -window => $blank,
	     -sticky => 'nsew',
	    );
	}
      } elsif ($fieldname eq "IRT") {
	# set the color based on the status
	my $time = $res2->{$id}->{$fieldname};
	# go ahead and derive a color for the response code
	# gold silver bronze, etc
	my $color;
	if (! defined $time) {

	} elsif ($time < 1) {
	  $color = "gold";
	} elsif ($time < 3) {
	  $color = "#F6F9F9";	# silver
	} elsif ($time < 7) {
	  $color = "#9C6963";	# bronze
	}
	my $blank;
	if (defined $color) {
	  $blank = $table->Label
	    (
	     -text => $time,
	     -background => $color,
	     -cursor => ['left_ptr'],
	    );
	} else {
	  $blank = $table->Label
	    (
	     -text => $time,
	     -cursor => ['left_ptr'],
	    );
	}
	$table->windowConfigure
	  (
	   "$row,$col3",
	   -window => $blank,
	   -sticky => 'nsew',
	  );
      } elsif ($fieldname eq "Ethics") {
	# set the color based on the status
	# analyze the text of the item to see how bad the morality is
	my $ethicality = CalculateEthics();
	my $gradescale = {
			  "A+" => 1,
			  "A" => 0.933,
			  "A-" => 0.9,
			  "B+" => 0.867,
			  "B" => 0.833,
			  "B-" => 0.80,
			  "C+" => 0.767,
			  "C" => 0.733,
			  "C-" => 0.70,
			  "D+" => 0.667,
			  "D" => 0.633,
			  "D-" => 0.6,
			  "F" => 0,
			 };
	my $colorscale = {
			  "A" => "gold",
			  "B" => "#F6F9F9", # silver
			  "C" => "#9C6963", # bronze
			 };
	my $finalgrade = "F";
	foreach my $grade (sort {$gradescale->{$b} <=> $gradescale->{$a}} keys %$gradescale) {
	  if ($ethicality >= $gradescale->{$grade}) {
	    $finalgrade = $grade;
	    last;
	  }
	}
	my $color;
	foreach my $grade (keys %$colorscale) {
	  if ($finalgrade =~ /$grade/) {
	    $color = $colorscale->{$grade};
	    last;
	  }
	}
	my $blank;
	if (defined $color) {
	  $blank = $table->Label
	    (
	     -text => $finalgrade,
	     -background => $color,
	     -cursor => ['left_ptr'],
	    );
	} else {
	  $blank = $table->Label
	    (
	     -text => $finalgrade,
	     -cursor => ['left_ptr'],
	    );
	}
	$table->windowConfigure
	  (
	   "$row,$col3",
	   -window => $blank,
	   -sticky => 'nsew',
	  );
      } elsif ($fieldname eq "Similarity") {
	# set the color based on the status
	my $similarity = CalculateSimilarity();
	$table->set("$row,$col3", '%'.int($similarity));
      } else {
	my $label = $table->Label
	  (
	   -text => $res2->{$id}->{$fieldname},
	   -cursor => ['left_ptr'],
	  );
	$table->windowConfigure
	  (
	   "$row,$col3",
	   -window => $label,
	   -sticky => 'nsew',
	  );
	# $table->set("$row,$col3", $res2->{$id}->{$fieldname});
      }
      ++$col3;
    }
    ++$row;
  }

  $table->pack
    (
     -expand => 1,
     -fill => 'both',
    );
}

# add ethical violations stuff here as well

# have a spreadsheet, see how to do that, that we can click on and
# launch stuff from

# configuration system

# IMAP response system

# deal with this later

sub ProcessIMAPEntries {
  my %args = @_;
  # load everything recently
}

sub ViewHistory {
  my %args = @_;
  # create a new database table

  # status
  # history

  # time_elapsed_since_last_history
  # time_to_initial_response
  # time_since_my_response
  # time_since_their_response
}

sub PerformStateTransition {
  my %args = @_;
  # prompt the user for participation
  my $statetransitions =
    {
     "unread" => {
		  "read" => "seen",
		  "cancel" => "unread",
		  "reset" => "unread",
		  "total reset" => "unread",
		 },
     "seen" => {
		"apply" => "their turn",
		"ignore" => "ignored",
		"cancel" => "unread",
		"reset" => "unread",
		"total reset" => "unread",
	       },
     "ignored" => {
		   "apply" => "their turn",
		   "cancel" => "unread",
		   "reset" => "unread",
		   "total reset" => "unread",
		  },
     "their turn" => {
		      "got response" => "our turn",
		      "cancel" => "unread",
		      "reset" => "unread",
		      "total reset" => "unread",
		     },
     "our turn" => {
		    "got job" => "job acquired",
		    "respond" => "their turn",
		    "cancel" => "unread",
		    "reset" => "unread",
		    "total reset" => "unread",
		   },
     "job acquired" => {
			"successful completion" => "job finished",
			"quit" => "job finished",
			"fired" => "job finished",
			"cancel" => "unread",
			"reset" => "unread",
			"total reset" => "unread",
		       },
     "job finished" => {
			"payment acquired" => "paid",
			# "cancel" => "unread",
			# "reset" => "unread",
			# "total reset" => "unread",
		       },
     "paid" => {
	       },
    };
  # pop up a menu asking which of the following occurred

  # first get the location of the mouse click
  my $menu = $top1->Menu(-tearoff => 0);
  # add each of the operations for the current status
  my @menuitems = keys %{$statetransitions->{$args{Status}}};
  foreach my $menuitem (@menuitems) {
    $menu->add
      (
       'command',
       -label => $menuitem,
       -command => sub {
	 # execute this action for this menuitem
	 print $args{Key}."\n";
       },
      );
  }
  my $screenx = $top1->winfo('pointerx');
  my $screeny = $top1->winfo('pointery');
  $menu->post($screenx, $screeny);
}

sub CalculateEthics {
  my %args = @_;
  my $ethicalviolations =
    {
     "patent" => 1,
    };
  return rand(1.0);
}

sub CalculateSimilarity {
  my %args = @_;
  return rand(100.0);
}
